> For the complete documentation index, see [llms.txt](https://docs.mezzanine.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mezzanine.xyz/smart-contracts/source-code/core/department/generaldepartment.md).

# GeneralDepartment

[Git Source](https://github.com/EntreDevelopers-Lab-Inc/Mezz-Companies/blob/f7a3e84e3dd5bb33c4bd7f77283983f9e8ba20b2/src/core/departments/general/GeneralDepartment.sol)

**Inherits:** Department

**Author:** Daniel Yamagata & Naveen Ailawadi

A simple department which solely inherits the base functionality

## Functions

### constructor

```solidity
constructor(address _mezzHub, address _mezzMigrator) Department(_mezzHub, _mezzMigrator);
```

### init

Standardized init function that all departments must inherit

```solidity
function init(
    address initTreasury,
    address[] memory _owners,
    uint256 _threshhold,
    address initGuard,
    address initParent,
    bytes memory params
) external virtual override initializer;
```

**Parameters**

| Name           | Type        | Description                                                                                |
| -------------- | ----------- | ------------------------------------------------------------------------------------------ |
| `initTreasury` | `address`   | The address of the treasury                                                                |
| `_owners`      | `address[]` | The initial signers of the department's multisig                                           |
| `_threshhold`  | `uint256`   | The initial threshold of the department's multisig                                         |
| `initGuard`    | `address`   | The address of the guard contract, which should be deployed atomically with the department |
| `initParent`   | `address`   | The address of the department's parent                                                     |
| `params`       | `bytes`     | Any additional parameters that the department needs to initialize                          |

### \_\_GeneralDepartment\_init

*Sets the 'departmentName' and calls the department's internal init function. The 'name' of the contract will be the concatenation of the company name, the department name, and " Department". For example, if the company name is "Foo" and 'departmentName' is "Bar", the contract name will be "Foo Bar Department".*

```solidity
function __GeneralDepartment_init(
    address initTreasury,
    address[] memory _owners,
    uint256 _threshhold,
    address initGuard,
    address initParent,
    bytes memory params
) internal virtual onlyInitializing;
```

### coreId

Returns the coreId of the implementation as a bytes32

*The core ID is the keccak256 hash of the contract name followed by a version under the following syntax: "mezzanine.coreId.ContractName.vX" For example, the core ID of the 2nd version of the Treasury would be the following: keccak256(abi.encodePacked("mezzanine.coreId.Treasury.v2"))*

```solidity
function coreId() public pure virtual override(Credentialed, ICredentialed) returns (bytes32);
```

### version

Returns the version of the implementation as a uint256

```solidity
function version() public pure virtual override(Credentialed, ICredentialed) returns (uint256);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.mezzanine.xyz/smart-contracts/source-code/core/department/generaldepartment.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
